#ifndef __glut_inc__
#define __glut_inc__

/* Copyright (c) Mark J. Kilgard, 1994, 1995, 1996, 1998. */

/* This program is freely distributable without licensing fees  and is
   provided without guarantee or warrantee expressed or  implied. This
   program is -not- in the public domain. */


/* GLUT 3.7 now tries to avoid including <windows.h>
   to avoid name space pollution, but Win32's <GL/gl.h> 
   needs APIENTRY and WINGDIAPI defined properly. */



   /* XXX This is from Win32's <ctype.h> */
#ifndef _WCHAR_T_DEFINED
#typedef wchar_t unsigned word
#define _WCHAR_T_DEFINED
#endif


#use "winmm.lib"     /* link with Windows MultiMedia lib */
#use "opengl32.lib"  /* link with Microsoft OpenGL lib */
#use "glu32.lib"     /* link with OpenGL Utility lib */
#use "glut32.lib"    /* link with Win32 GLUT lib */



// The G3D OpenGL headers contain header guards that prevent
// the system headers from actually being included here; the
// #include gl.h from glu and gl.h will effectively be ignored.
#ifndef __gl_inc__
  #ifndef G3D_GRAPHICS3D_H
//	 #emit %error "G3DAll.inc must be included *before* glut.h to prevent OpenGL header conflicts"
  #else
//     #emit %error "G3D must be used with its own version of GL/gl.inc; your glut.inc tried to include the system version of GL/gl.inc instead (somehow)"
  #endif
#endif 

#include "GL\\gl.inc"
#include "GL\\glu.inc"





/**
 GLUT API revision history:
 
 GLUT_API_VERSION is updated to reflect incompatible GLUT
 API changes (interface changes, semantic changes, deletions,
 or additions).
 
 GLUT_API_VERSION=1  First public release of GLUT.  11/29/94

 GLUT_API_VERSION=2  Added support for OpenGL/GLX multisampling,
 extension.  Supports new input devices like tablet, dial and button
 box, and Spaceball.  Easy to query OpenGL extensions.

 GLUT_API_VERSION=3  glutMenuStatus added.

 GLUT_API_VERSION=4  glutInitDisplayString, glutWarpPointer,
 glutBitmapLength, glutStrokeLength, glutWindowStatusFunc, dynamic
 video resize subAPI, glutPostWindowRedisplay, glutKeyboardUpFunc,
 glutSpecialUpFunc, glutIgnoreKeyRepeat, glutSetKeyRepeat,
 glutJoystickFunc, glutForceJoystickFunc (NOT FINALIZED!).
**/
#ifndef GLUT_API_VERSION  /* allow this to be overriden */
#define GLUT_API_VERSION		3
#endif

/**
 GLUT implementation revision history:
 
 GLUT_XLIB_IMPLEMENTATION is updated to reflect both GLUT
 API revisions and implementation revisions (ie, bug fixes).

 GLUT_XLIB_IMPLEMENTATION=1  mjk's first public release of
 GLUT Xlib-based implementation.  11/29/94

 GLUT_XLIB_IMPLEMENTATION=2  mjk's second public release of
 GLUT Xlib-based implementation providing GLUT version 2 
 interfaces.

 GLUT_XLIB_IMPLEMENTATION=3  mjk's GLUT 2.2 images. 4/17/95

 GLUT_XLIB_IMPLEMENTATION=4  mjk's GLUT 2.3 images. 6/?/95

 GLUT_XLIB_IMPLEMENTATION=5  mjk's GLUT 3.0 images. 10/?/95

 GLUT_XLIB_IMPLEMENTATION=7  mjk's GLUT 3.1+ with glutWarpPoitner.  7/24/96

 GLUT_XLIB_IMPLEMENTATION=8  mjk's GLUT 3.1+ with glutWarpPoitner
 and video resize.  1/3/97

 GLUT_XLIB_IMPLEMENTATION=9 mjk's GLUT 3.4 release with early GLUT 4 routines.

 GLUT_XLIB_IMPLEMENTATION=11 Mesa 2.5's GLUT 3.6 release.

 GLUT_XLIB_IMPLEMENTATION=12 mjk's GLUT 3.6 release with early GLUT 4 routines + signal handling.

 GLUT_XLIB_IMPLEMENTATION=13 mjk's GLUT 3.7 release with GameGLUT support.
**/
#ifndef GLUT_XLIB_IMPLEMENTATION  /* Allow this to be overriden. */
#define GLUT_XLIB_IMPLEMENTATION	13
#endif

/* Display mode bit masks. */
#define GLUT_RGB			0
#define GLUT_RGBA			GLUT_RGB
#define GLUT_INDEX			1
#define GLUT_SINGLE			0
#define GLUT_DOUBLE			2
#define GLUT_ACCUM			4
#define GLUT_ALPHA			8
#define GLUT_DEPTH			16
#define GLUT_STENCIL			32
#define GLUT_MULTISAMPLE		128
#define GLUT_STEREO			256
#define GLUT_LUMINANCE			512

/* Mouse buttons. */
#define GLUT_LEFT_BUTTON		0
#define GLUT_MIDDLE_BUTTON		1
#define GLUT_RIGHT_BUTTON		2

/* Mouse button  state. */
#define GLUT_DOWN			0
#define GLUT_UP				1

/* function keys */
#define GLUT_KEY_F1			1
#define GLUT_KEY_F2			2
#define GLUT_KEY_F3			3
#define GLUT_KEY_F4			4
#define GLUT_KEY_F5			5
#define GLUT_KEY_F6			6
#define GLUT_KEY_F7			7
#define GLUT_KEY_F8			8
#define GLUT_KEY_F9			9
#define GLUT_KEY_F10			10
#define GLUT_KEY_F11			11
#define GLUT_KEY_F12			12
/* directional keys */
#define GLUT_KEY_LEFT			100
#define GLUT_KEY_UP			101
#define GLUT_KEY_RIGHT			102
#define GLUT_KEY_DOWN			103
#define GLUT_KEY_PAGE_UP		104
#define GLUT_KEY_PAGE_DOWN		105
#define GLUT_KEY_HOME			106
#define GLUT_KEY_END			107
#define GLUT_KEY_INSERT			108

/* Entry/exit  state. */
#define GLUT_LEFT			0
#define GLUT_ENTERED			1

/* Menu usage  state. */
#define GLUT_MENU_NOT_IN_USE		0
#define GLUT_MENU_IN_USE		1

/* Visibility  state. */
#define GLUT_NOT_VISIBLE		0
#define GLUT_VISIBLE			1

/* Window status  state. */
#define GLUT_HIDDEN			0
#define GLUT_FULLY_RETAINED		1
#define GLUT_PARTIALLY_RETAINED		2
#define GLUT_FULLY_COVERED		3

/* Color index component selection values. */
#define GLUT_RED			0
#define GLUT_GREEN			1
#define GLUT_BLUE			2

/* Layers for use. */
#define GLUT_NORMAL			0
#define GLUT_OVERLAY			1

//# if defined(_WIN32)
/* Stroke font constants (use these in GLUT program). */
#define GLUT_STROKE_ROMAN		(0)
#define GLUT_STROKE_MONO_ROMAN		(1)

/* Bitmap font constants (use these in GLUT program). */
#define GLUT_BITMAP_9_BY_15		(2)
#define GLUT_BITMAP_8_BY_13		(3)
#define GLUT_BITMAP_TIMES_ROMAN_10	(4)
#define GLUT_BITMAP_TIMES_ROMAN_24	(5)

#define GLUT_BITMAP_HELVETICA_10	(6)
#define GLUT_BITMAP_HELVETICA_12	(7)
#define GLUT_BITMAP_HELVETICA_18	(8)

/*# else
// Stroke font opaque addresses (use constants instead in source code).
extern void *glutStrokeRoman;
extern void *glutStrokeMonoRoman;

// Stroke font constants (use these in GLUT program).
#define GLUT_STROKE_ROMAN		(&glutStrokeRoman)
#define GLUT_STROKE_MONO_ROMAN		(&glutStrokeMonoRoman)

// Bitmap font opaque addresses (use constants instead in source code).
extern void *glutBitmap9By15;
extern void *glutBitmap8By13;
extern void *glutBitmapTimesRoman10;
extern void *glutBitmapTimesRoman24;
extern void *glutBitmapHelvetica10;
extern void *glutBitmapHelvetica12;
extern void *glutBitmapHelvetica18;

// Bitmap font constants (use these in GLUT program).
#define GLUT_BITMAP_9_BY_15		(&glutBitmap9By15)
#define GLUT_BITMAP_8_BY_13		(&glutBitmap8By13)
#define GLUT_BITMAP_TIMES_ROMAN_10	(&glutBitmapTimesRoman10)
#define GLUT_BITMAP_TIMES_ROMAN_24	(&glutBitmapTimesRoman24)

#define GLUT_BITMAP_HELVETICA_10	(&glutBitmapHelvetica10)
#define GLUT_BITMAP_HELVETICA_12	(&glutBitmapHelvetica12)
#define GLUT_BITMAP_HELVETICA_18	(&glutBitmapHelvetica18)

# endif*/

/* glutGet parameters. */
#define GLUT_WINDOW_X			100
#define GLUT_WINDOW_Y			101
#define GLUT_WINDOW_WIDTH		102
#define GLUT_WINDOW_HEIGHT		103
#define GLUT_WINDOW_BUFFER_SIZE		104
#define GLUT_WINDOW_STENCIL_SIZE	105
#define GLUT_WINDOW_DEPTH_SIZE		106
#define GLUT_WINDOW_RED_SIZE		107
#define GLUT_WINDOW_GREEN_SIZE		108
#define GLUT_WINDOW_BLUE_SIZE		109
#define GLUT_WINDOW_ALPHA_SIZE		110
#define GLUT_WINDOW_ACCUM_RED_SIZE	111
#define GLUT_WINDOW_ACCUM_GREEN_SIZE	112
#define GLUT_WINDOW_ACCUM_BLUE_SIZE	113
#define GLUT_WINDOW_ACCUM_ALPHA_SIZE	114
#define GLUT_WINDOW_DOUBLEBUFFER	115
#define GLUT_WINDOW_RGBA		116
#define GLUT_WINDOW_PARENT		117
#define GLUT_WINDOW_NUM_CHILDREN	118
#define GLUT_WINDOW_COLORMAP_SIZE	119

#define GLUT_WINDOW_NUM_SAMPLES		120
#define GLUT_WINDOW_STEREO		121

#define GLUT_WINDOW_CURSOR		122
#define GLUT_SCREEN_WIDTH		200
#define GLUT_SCREEN_HEIGHT		201
#define GLUT_SCREEN_WIDTH_MM		202
#define GLUT_SCREEN_HEIGHT_MM		203
#define GLUT_MENU_NUM_ITEMS		300
#define GLUT_DISPLAY_MODE_POSSIBLE	400
#define GLUT_INIT_WINDOW_X		500
#define GLUT_INIT_WINDOW_Y		501
#define GLUT_INIT_WINDOW_WIDTH		502
#define GLUT_INIT_WINDOW_HEIGHT		503
#define GLUT_INIT_DISPLAY_MODE		504
#define GLUT_ELAPSED_TIME		700
#define GLUT_WINDOW_FORMAT_ID		123

/* glutDeviceGet parameters. */
#define GLUT_HAS_KEYBOARD		600
#define GLUT_HAS_MOUSE			601
#define GLUT_HAS_SPACEBALL		602
#define GLUT_HAS_DIAL_AND_BUTTON_BOX	603
#define GLUT_HAS_TABLET			604
#define GLUT_NUM_MOUSE_BUTTONS		605
#define GLUT_NUM_SPACEBALL_BUTTONS	606
#define GLUT_NUM_BUTTON_BOX_BUTTONS	607
#define GLUT_NUM_DIALS			608
#define GLUT_NUM_TABLET_BUTTONS		609
#define GLUT_DEVICE_IGNORE_KEY_REPEAT   610
#define GLUT_DEVICE_KEY_REPEAT          611
#define GLUT_HAS_JOYSTICK		612
#define GLUT_OWNS_JOYSTICK		613
#define GLUT_JOYSTICK_BUTTONS		614
#define GLUT_JOYSTICK_AXES		615
#define GLUT_JOYSTICK_POLL_RATE		616

/* glutLayerGet parameters. */
#define GLUT_OVERLAY_POSSIBLE           800
#define GLUT_LAYER_IN_USE		801
#define GLUT_HAS_OVERLAY		802
#define GLUT_TRANSPARENT_INDEX		803
#define GLUT_NORMAL_DAMAGED		804
#define GLUT_OVERLAY_DAMAGED		805

/* glutVideoResizeGet parameters. */
#define GLUT_VIDEO_RESIZE_POSSIBLE	900
#define GLUT_VIDEO_RESIZE_IN_USE	901
#define GLUT_VIDEO_RESIZE_X_DELTA	902
#define GLUT_VIDEO_RESIZE_Y_DELTA	903
#define GLUT_VIDEO_RESIZE_WIDTH_DELTA	904
#define GLUT_VIDEO_RESIZE_HEIGHT_DELTA	905
#define GLUT_VIDEO_RESIZE_X		906
#define GLUT_VIDEO_RESIZE_Y		907
#define GLUT_VIDEO_RESIZE_WIDTH		908
#define GLUT_VIDEO_RESIZE_HEIGHT	909

/* glutUseLayer parameters. */
#define GLUT_NORMAL			0
#define GLUT_OVERLAY			1

/* glutGetModifiers return mask. */
#define GLUT_ACTIVE_SHIFT               1
#define GLUT_ACTIVE_CTRL                2
#define GLUT_ACTIVE_ALT                 4

/* glutSetCursor parameters. */
/* Basic arrows. */
#define GLUT_CURSOR_RIGHT_ARROW		0
#define GLUT_CURSOR_LEFT_ARROW		1
/* Symbolic cursor shapes. */
#define GLUT_CURSOR_INFO		2
#define GLUT_CURSOR_DESTROY		3
#define GLUT_CURSOR_HELP		4
#define GLUT_CURSOR_CYCLE		5
#define GLUT_CURSOR_SPRAY		6
#define GLUT_CURSOR_WAIT		7
#define GLUT_CURSOR_TEXT		8
#define GLUT_CURSOR_CROSSHAIR		9
/* Directional cursors. */
#define GLUT_CURSOR_UP_DOWN		10
#define GLUT_CURSOR_LEFT_RIGHT		11
/* Sizing cursors. */
#define GLUT_CURSOR_TOP_SIDE		12
#define GLUT_CURSOR_BOTTOM_SIDE		13
#define GLUT_CURSOR_LEFT_SIDE		14
#define GLUT_CURSOR_RIGHT_SIDE		15
#define GLUT_CURSOR_TOP_LEFT_CORNER	16
#define GLUT_CURSOR_TOP_RIGHT_CORNER	17
#define GLUT_CURSOR_BOTTOM_RIGHT_CORNER	18
#define GLUT_CURSOR_BOTTOM_LEFT_CORNER	19
/* Inherit from parent window. */
#define GLUT_CURSOR_INHERIT		100
/* Blank cursor. */
#define GLUT_CURSOR_NONE		101
/* Fullscreen crosshair (if available). */
#define GLUT_CURSOR_FULL_CROSSHAIR	102


/* GLUT initialization sub-API. */
declare import, glutInit(int *argcp, char *argv);
declare import, glutInitDisplayMode(unsigned int mode);
declare import, glutInitDisplayString(char *pstring);
declare import, glutInitWindowPosition(int x, int y);
declare import, glutInitWindowSize(int width, int height);
declare import, glutMainLoop();

/* GLUT window sub-API. */
declare import, glutCreateWindow(char *title),int;
declare import, glutCreateSubWindow(int win, int x, int y, int width, int height),int;
declare import, glutDestroyWindow(int win);
declare import, glutPostRedisplay();
declare import, glutPostWindowRedisplay(int win);
declare import, glutSwapBuffers();
declare import, glutGetWindow(),int;
declare import, glutSetWindow(int win);
declare import, glutSetWindowTitle(char *title);
declare import, glutSetIconTitle(char *title);
declare import, glutPositionWindow(int x, int y);
declare import, glutReshapeWindow(int width, int height);
declare import, glutPopWindow();
declare import, glutPushWindow();
declare import, glutIconifyWindow();
declare import, glutShowWindow();
declare import, glutHideWindow();
declare import, glutFullScreen();
declare import, glutSetCursor(int cursor);
declare import, glutWarpPointer(int x, int y);

/* GLUT overlay sub-API. */
declare import, glutEstablishOverlay();
declare import, glutRemoveOverlay();
declare import, glutUseLayer(GLenum layer);
declare import, glutPostOverlayRedisplay();
declare import, glutPostWindowOverlayRedisplay(int win);
declare import, glutShowOverlay();
declare import, glutHideOverlay();

/* GLUT menu sub-API. */
declare import, glutCreateMenu(int fn/*void (*)(int)*/),int;
declare import, glutDestroyMenu(int menu);
declare import, glutGetMenu(),int;
declare import, glutSetMenu(int menu);
declare import, glutAddMenuEntry(char *_label, int value);
declare import, glutAddSubMenu(char *_label, int submenu);
declare import, glutChangeToMenuEntry(int item, char *_label, int value);
declare import, glutChangeToSubMenu(int item, char *_label, int submenu);
declare import, glutRemoveMenuItem(int item);
declare import, glutAttachMenu(int button);
declare import, glutDetachMenu(int button);

/* GLUT window callback sub-API. */
declare import, glutDisplayFunc(int fn/*void (*func)()*/);
declare import, glutReshapeFunc(int fn/*void (*func)(int width, int height)*/);
declare import, glutKeyboardFunc(int fn/*void (*func)(unsigned byte key, int x, int y)*/);
declare import, glutMouseFunc(int fn/*void (*func)(int button, int state, int x, int y)*/);
declare import, glutMotionFunc(int fn/*void (*func)(int x, int y)*/);
declare import, glutPassiveMotionFunc(int fn/*void (*func)(int x, int y)*/);
declare import, glutEntryFunc(int fn/*void (*func)(int state)*/);
declare import, glutVisibilityFunc(int fn/*void (*func)(int state)*/);
declare import, glutIdleFunc(int fn/*void (*func)()*/);
declare import, glutTimerFunc(int millis, int fn/*void (*func)(int value)*/, int value);
declare import, glutMenuStateFunc(int fn/*void (*func)(int state)*/);
declare import, glutSpecialFunc(int fn/*void (*func)(int key, int x, int y)*/);
declare import, glutSpaceballMotionFunc(int fn/*void (*func)(int x, int y, int z)*/);
declare import, glutSpaceballRotateFunc(int fn/*void (*func)(int x, int y, int z)*/);
declare import, glutSpaceballButtonFunc(int fn/*void (*func)(int button, int state)*/);
declare import, glutButtonBoxFunc(int fn/*void (*func)(int button, int state)*/);
declare import, glutDialsFunc(int fn/*void (*func)(int dial, int value)*/);
declare import, glutTabletMotionFunc(int fn/*void (*func)(int x, int y)*/);
declare import, glutTabletButtonFunc(int fn/*void (*func)(int button, int state, int x, int y)*/);
declare import, glutMenuStatusFunc(int fn/*void (*func)(int status, int x, int y)*/);
declare import, glutOverlayDisplayFunc(int fn/*void (*func)()*/);
declare import, glutWindowStatusFunc(int fn/*void (*func)(int state)*/);
declare import, glutKeyboardUpFunc(int fn/*void (*func)(unsigned byte key, int x, int y)*/);
declare import, glutSpecialUpFunc(int fn/*void (*func)(int key, int x, int y)*/);
declare import, glutJoystickFunc(int fn/*void (*func)(unsigned int buttonMask, int x, int y, int z)*/, int pollInterval);

/* GLUT color index sub-API. */
declare import, glutSetColor(int i, GLfloat red, GLfloat green, GLfloat blue);
declare import, glutGetColor(int ndx, int component),GLfloat;
declare import, glutCopyColormap(int win);

/* GLUT state retrieval sub-API. */
declare import, glutGet(GLenum type),int;
declare import, glutDeviceGet(GLenum type),int;
/* GLUT extension support sub-API */
declare import, glutExtensionSupported(char *name),int;
declare import, glutGetModifiers(),int;
declare import, glutLayerGet(GLenum type),int;

/* GLUT font sub-API */
declare import, glutBitmapCharacter(void *font, int character);
declare import, glutBitmapWidth(void *font, int character),int;
declare import, glutStrokeCharacter(void *font, int character);
declare import, glutStrokeWidth(void *font, int character),int;
declare import, glutBitmapLength(void *font, unsigned byte *pstring),int;
declare import, glutStrokeLength(void *font, unsigned byte *pstring),int;

/* GLUT pre-built models sub-API */
declare import, glutWireSphere(GLdouble radius, GLint slices, GLint stacks);
declare import, glutSolidSphere(GLdouble radius, GLint slices, GLint stacks);
declare import, glutWireCone(GLdouble base, GLdouble height, GLint slices, GLint stacks);
declare import, glutSolidCone(GLdouble base, GLdouble height, GLint slices, GLint stacks);
declare import, glutWireCube(GLdouble size);
declare import, glutSolidCube(GLdouble size);
declare import, glutWireTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings);
declare import, glutSolidTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings);
declare import, glutWireDodecahedron();
declare import, glutSolidDodecahedron();
declare import, glutWireTeapot(GLdouble size);
declare import, glutSolidTeapot(GLdouble size);
declare import, glutWireOctahedron();
declare import, glutSolidOctahedron();
declare import, glutWireTetrahedron();
declare import, glutSolidTetrahedron();
declare import, glutWireIcosahedron();
declare import, glutSolidIcosahedron();

/* GLUT video resize sub-API. */
declare import, glutVideoResizeGet(GLenum param),int;
declare import, glutSetupVideoResizing();
declare import, glutStopVideoResizing();
declare import, glutVideoResize(int x, int y, int width, int height);
declare import, glutVideoPan(int x, int y, int width, int height);

/* GLUT debugging sub-API. */
declare import, glutReportErrors();

/* GLUT device control sub-API. */
/* glutSetKeyRepeat modes. */
#define GLUT_KEY_REPEAT_OFF		0
#define GLUT_KEY_REPEAT_ON		1
#define GLUT_KEY_REPEAT_DEFAULT		2

/* Joystick button masks. */
#define GLUT_JOYSTICK_BUTTON_A		1
#define GLUT_JOYSTICK_BUTTON_B		2
#define GLUT_JOYSTICK_BUTTON_C		4
#define GLUT_JOYSTICK_BUTTON_D		8

declare import, glutIgnoreKeyRepeat(int ignore);
declare import, glutSetKeyRepeat(int repeatMode);
declare import, glutForceJoystickFunc();

/* GLUT game mode sub-API. */
/* glutGameModeGet. */
#define GLUT_GAME_MODE_ACTIVE           0
#define GLUT_GAME_MODE_POSSIBLE         1
#define GLUT_GAME_MODE_WIDTH            2
#define GLUT_GAME_MODE_HEIGHT           3
#define GLUT_GAME_MODE_PIXEL_DEPTH      4
#define GLUT_GAME_MODE_REFRESH_RATE     5
#define GLUT_GAME_MODE_DISPLAY_CHANGED  6

declare import, glutGameModeString(char *pstring);
declare import, glutEnterGameMode(),int;
declare import, glutLeaveGameMode();
declare import, glutGameModeGet(GLenum mode),int;







#endif
